package cn.estsh.i3plus.core.apiservice.serviceimpl.busi;

import cn.estsh.i3plus.core.api.iservice.busi.ITestService;
import cn.estsh.i3plus.core.apiservice.dao.ITestDao;
import cn.estsh.i3plus.platform.common.tool.StringTool;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.base.common.PagerHelper;
import cn.estsh.i3plus.pojo.base.enumutil.CommonEnumUtil;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.i3plus.pojo.base.tool.HqlPack;
import cn.estsh.i3plus.pojo.platform.bean.SysDepartment;
import cn.estsh.i3plus.pojo.platform.bean.SysOrganize;
import cn.estsh.i3plus.pojo.platform.bean.SysUser;
import cn.estsh.i3plus.pojo.platform.repository.SysUserRepository;
import cn.estsh.i3plus.pojo.platform.sqlpack.CoreHqlPack;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
 * @Description :
 * @Reference :
 * @Author : yunhao
 * @CreateDate : 2019-02-20 21:24
 * @Modify:
 **/
@Service
public class TestService implements ITestService {

    public static final Logger LOGGER = LoggerFactory.getLogger(TestService.class);

    @Autowired
    ITestDao testDao;

    @Autowired
    private SysUserRepository sysUserRDao;

    @Override
    @ApiOperation(value = "多表查询")
    public List<Object> queryToolAndToolType(Pager pager) {
        return testDao.queryToolAndToolType(pager);
    }

    @Override
    @ApiOperation(value = "账号分页查询", notes = "组合查询")
    public ListPager<SysUser> querySysUserByPager(SysUser user, Pager pager) {
        LOGGER.debug("系统用户 SysUser find user :{} page :{}", user, pager);

        //生成hql查询语句
        String hqlPack = CoreHqlPack.packHqlSysUser(user);
        pager = PagerHelper.getPager(pager, sysUserRDao.findByHqlWhereCount(hqlPack));
        ListPager<SysUser> list =  new ListPager(sysUserRDao.findByHqlWherePage(hqlPack + user.orderBy(), pager), pager);
        LOGGER.info("size:{},pager:{}",list.getObjectList().size(),list.getObjectPager());

//        DdlPackBean packBean = new DdlPackBean();
//        DdlPreparedPack.getNumEqualPackOverZero(CommonEnumUtil.IS_VAILD.VAILD.getValue(),"isValid",packBean);
//        DdlPreparedPack.getNumEqualPackOverZero(user.getDepartmentId(),"departmentId",packBean);
//        DdlPreparedPack.getNumEqualPackOverZero(user.getUserStatus(),"userStatus",packBean);
//        DdlPreparedPack.getStringLikerPack(user.getUserName(),"userName",packBean);
//        DdlPreparedPack.getStringLikerPack(user.getUserLoginName(),"userLoginName",packBean);
//        DdlPreparedPack.getStringLikerPack(user.getUserEmail(),"userEmail",packBean);
//        DdlPreparedPack.getStringLikerPack(user.getUserPhone(),"userPhone",packBean);

        DdlPackBean packBean = CoreHqlPack.packDdlSysUser(user);
        System.out.println("getPackedHql=="+packBean.getPackedHql());
        System.out.println("getPackedHqlAll=="+packBean.getPackedHqlAll());
        System.out.println("getHqlAppend=="+packBean.getHqlAppend());
        System.out.println("getWhereAppend=="+packBean.getWhereAppend());
        System.out.println("getOrderByStr=="+packBean.getOrderByStr());

        pager = PagerHelper.getPager(pager, sysUserRDao.findByHqlWhereCount(packBean));
        list =  new ListPager(sysUserRDao.findByHqlWherePage(packBean, pager), pager);
        LOGGER.info("size:{},pager:{}",list.getObjectList().size(),list.getObjectPager());

        return list;
    }

    @Override
    public List<SysUser> querySysUserByPack(DdlPackBean packBean) {
        return sysUserRDao.findByHqlWhere(packBean);
    }
}
